const path = require('path')
const { app, clipboard, webContents, BrowserWindow, BrowserView, shell, Tray, Menu, nativeImage, MenuItem } = require('electron')
const isMac = process.platform === 'darwin'
const conMenu = require('electron-context-menu');
/*contextMenu(
	{
		append: () => [
			{
				menu: (actions, params, win, dicSuggestion) => [
					{
						label: 'Discord Server',
						click: () => open('https://vetpetmon.com/discord')
					},
					actions.separator(),
					actions.copy(),
					actions.cut(),
					actions.paste(),
					actions.separator(),
				],
			}
		]
	},
	{
		showSaveImageAs: false
	}
);*/
const createWindow = () => {
  const win = new BrowserWindow({ webPreferences: {spellcheck: true},titleBarStyle: 'hidden', titleBarOverlay: {
    color: '#2f3241',
    symbolColor: '#74b1be',
    height: 10
  },
  icon: 'snazpedia.png',width: 800, height: 600, show: false, backgroundColor: '#14181f' })
  win.loadURL('https://wiki.vetpetmon.com/')
  win.once('ready-to-show', () => {
  win.show()
  })
  
  conMenu(
	{
		/*menu: (actions, params, win, dicSuggestion) => [
			{
				label: 'Discord Server',
				click: () => {shell.openExternal('https://vetpetmon.com/discord')}
			},
			{
				label: 'Search Duckduckgo for “{selection}”',
				// Only show it when right-clicking text
				visible: parameters.selectionText.trim().length > 0,
				click: () => {
					shell.openExternal(`https://duckduckgo.com/?q=${encodeURIComponent(parameters.selectionText)}`);
				}
			},
			actions.separator(),
			actions.copy(),
			actions.cut(),
			actions.paste(),
			actions.separator()
		]*/
	showCopyImage: false, showCopyImageAddress: true, showSearchWithGoogle: false,
	prepend: (defaultActions, parameters, browserWindow) => [
		{
			label: 'Discord',
			click: () => {
				shell.openExternal(`https://vetpetmon.com/discord`);
			}
		},
		{
                label: 'Copy page URL',
                click: () => {
					clipboard.writeText(win.webContents.getURL())
				}
            },
		{
			label: 'Search Duckduckgo for “{selection}”',
			// Only show it when right-clicking text
			visible: parameters.selectionText.trim().length > 0,
			click: () => {
				shell.openExternal(`https://duckduckgo.com/?q=${encodeURIComponent(parameters.selectionText)}`);
			}
		}
	]
	}
  )
}

let tray
app.whenReady().then(() => {
  const icon = nativeImage.createFromPath('snazpedia.png')
  tray = new Tray(icon)
  const contextMenu = Menu.buildFromTemplate([
    { label: 'Item1', type: 'radio' },
    { label: 'Item2', type: 'radio' },
    { label: 'Item3', type: 'radio', checked: true },
    { label: 'Item4', type: 'radio' }
  ])

  tray.setToolTip('SNAZpedia')
  tray.setContextMenu(contextMenu)
  createWindow()
  app.on('activate', () => {
    if (BrowserWindow.getAllWindows().length === 0) createWindow()
  })
})
app.on('window-all-closed', () => {
  if (process.platform !== 'darwin') app.quit()
})
/*app.on('web-contents-created', (event, webContents) => {
	contextMenu({
		menu: (actions, params, win, dicSuggestion) => [
			{
                label: 'Discord Server',
                click: () => open('https://vetpetmon.com/discord')
            },
			actions.separator(),
            actions.copy(),
            actions.cut(),
            actions.paste(),
            actions.separator(),
		],
		window: webContents
	});
});
*/